Bug 841891 - Potential tx lock leaks when nodes are added to the cluster
Potential tx lock leaks when nodes are added to the cluster
Status: VERIFIED
Product: JBoss Data Grid 6
Classification: JBoss
Component: Infinispan (Show other bugs)
6.0.0
Unspecified Unspecified
high Severity high
: ER6
: 6.1.0
Assigned To: Tristan Tarrant
nobody nobody
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-20 09:48 EDT by Tristan Tarrant
Modified: 2014-11-30 16:15 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Known Issue
Doc Text:
This situation only occurs during topology changes and results in certain keys remaining locked after a transaction is finished. This means that no other transaction is able to write to the given key while it is locked (though it can still be read). As a workaround, one can enable transaction recovery and then use the JMX recovery hooks in order to cleanup the pending lock.
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker ISPN-2137 Critical Resolved Potential tx lock leaks when nodes are added to the cluster 2015-10-21 10:08 EDT

  None (edit)
Description Tristan Tarrant 2012-07-20 09:48:35 EDT

    
Comment 1 mark yarborough 2012-08-22 09:44:22 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
CCFR from mmarkus
Comment 2 Mircea Markus 2012-08-22 10:52:58 EDT
This situation only happens during topology changes and results in certain key remaining locked after a transaction is finished. This means that no other transaction would be able to write the given key as long as they are locked (would be able to read them though). 
ISPN-2137 contains a workaround for recovering from these situation.
Comment 4 JBoss JIRA Server 2012-10-12 13:13:43 EDT
Adrian Nistor <anistor@redhat.com> made a comment on jira ISPN-2137

Integrated.
Comment 5 mark yarborough 2012-11-14 09:42:19 EST
ttarrant will add jira links as appropriate.
Comment 6 Michal Linhard 2012-12-19 10:15:33 EST
VERIFIED for 6.1.0.ER6

I've taken test: LockCleanupStateTransferTest (+added it to 5.1.5.FINAL)

and ran it for
5.1.5.FINAL - Failed
5.2.0.Beta6 - Passed

Note:
(the ER6 JAR was taken from MEAD repo - btw not md5sum-same as the JAR in jboss-datagrid-library-6.1.0.ER6.zip)

JAR in jboss-datagrid-library-6.1.0.ER6.zip: b8de37f0bd621246585a4de5939c66de
JAR in repo: a122144dac3b9d3e767389207bf6815a

(I tested both JARs)

The point of failure for 5.1.5.FINAL was here
https://github.com/infinispan/infinispan/blob/master/core/src/test/java/org/infinispan/tx/LockCleanupStateTransferTest.java#L152

Which IMO correspondes to the failing scenario described in ISPN-2137

Note You need to log in before you can comment on or make changes to this bug.